Lookahead Assertions
====================

Fountain has (or will have) a general notion of lookahead assertions.

A lookahead assertion is a constraint that says, "at this point, if
we tried to parse S (where S is some sub-grammar), we would succeed".

There are a few things to note about them.

A lookahead assertion does not consume any input.

In the presence of lookahead assertions, an ordered choice operator
is not necessary, because ordered choice can be simulated.  Suppose
ordered choice is denoted by `/`, and `?A` is our lookahead assertion
operator.  Then

    A / B == ?B A | B

Lookahead assertions can also serve the same function as conjunctive
grammars; we can assert that the tokens to come conform to one
syntactic structure, and actually parse a second syntactic structure,
meaning the parse will only succeed if the string conforms to both
structures -- the same as conjunction in conjuctive grammars.

Lookahead assertions only make sense during parsing, so in the context
of Fountain, we need to figure out what to do with them during generation.

We will disgregard them completely during generation.  They do not
evaluate to either true or false; they are simply not evaluated at all.
They are removed from the constraint expressions that will be evaluated.
