-- Copyright (c) 2023-2024 Chris Pressey, Cat's Eye Technologies
-- This file is distributed under a BSD license.  See LICENSES directory:
-- SPDX-License-Identifier: LicenseRef-BSD-2-Clause-X-Fountain

module Language.Fountain.Value where

import qualified Data.Map as Map


type Dict = Map.Map String Value

data Value = IntVal Integer
           | StrVal String
           | NameVal String
           | DictVal Dict
    deriving (Ord, Eq)

instance Show Value where
    show (IntVal n) = show n
    show (StrVal s) = show s
    show (NameVal n) = n
    show (DictVal d) = show d
